<template>
  <div class="page" ref="page">
    <app-menu
      :title="title">
    </app-menu>
    <div class="ViewMenu">
      <div class="_left">
        <el-radio-group
          v-model="viewType"
          size="mini">
          <el-radio-button label="CHSH"></el-radio-button>
          <el-radio-button label="MD"></el-radio-button>
        </el-radio-group>
        <el-button
          style="margin-left: 10px"
          @click="editorSetFileCode();openDrawer()"
          size="mini">
          <i class="fa fa-pencil" aria-hidden="true"></i>
        </el-button>
        <el-button
          @click="openSublime"
          size="mini">
          <i class="fa fa-external-link" aria-hidden="true"></i>
        </el-button>
        <el-button
          @click="openFolder"
          size="mini">
          <i class="fa fa-folder" aria-hidden="true"></i>
        </el-button>
      </div>
      <div class="_center">
        <el-input
          ref="filterInput"
          size="medium"
          placeholder="Filter"
          class="_filterInput"
          v-model="filter"
          :clearable="true">
        </el-input>
      </div>
      <div class="_right">
        <el-button size="mini" v-if="changedData" @click="loadCheatSheet" type="info">
          <i class="fa fa-refresh" aria-hidden="true"></i>
        </el-button>
        <el-button size="mini" v-if="changedData" @click="saveCheatsheet" type="success">
          <i class="fa fa-floppy-o" aria-hidden="true"></i>
        </el-button>
        <el-button size="mini" type="warning">
          <i class="fa fa-sort-numeric-asc" aria-hidden="true"></i>
        </el-button>
        <el-button size="mini" type="primary" icon="el-icon-plus" @click="addChshBlock"></el-button>
      </div>
    </div>

    <vue-drawer-layout
      :content-drawable="true"
      :reverse="false"
      :enable="isDrawerEnabled"
      :drawer-width="800"
      @slide-end="handleSlideEnd"
      @mask-click="closeDrawer"
      style="height: calc(100vh - 80px);position: relative;top: 0px;"
      ref="drawer">
      <div class="DrawerContent" slot="drawer">
        <div
          class="_close"
          @click="closeDrawer">
          <i class="fa fa-times" aria-hidden="true"></i>
        </div>
        <div class="_menu">
          <el-autocomplete
            v-model="snippetsFilter"
            value-key="name"
            ref="snippetsFilter"
            @select="pasteSnippet($event)"
            :fetch-suggestions="snippetsSearch"
            :clearable="true"
            placeholder="Insert snippet"
            sile="mini"
            :trigger-on-focus="true"/>
          <el-autocomplete
            v-model="extCheatsheetsFilter"
            value-key="name"
            ref="extCheatsheatsFilter"
            @select="pasteExtCheatsheet($event)"
            :fetch-suggestions="extCheatsheetsSearch"
            :clearable="true"
            placeholder="Insert cheatsheet"
            sile="mini"
            :trigger-on-focus="true"/>
          <el-button-group>
            <el-button
              title="wrap by copy"
              @click="wrapByCopy"
              type="plain">
              <i class="fa fa-clipboard" aria-hidden="true"></i>
            </el-button>
            <el-button
              title="wrap by link"
              @click="wrapByLink"
              type="plain">
              <i class="fa fa-link" aria-hidden="true"></i>
            </el-button>
            <el-button
              title="wrap by round bracket"
              @click="wrapByRoundBracket"
              type="plain">
              ( )
            </el-button>
            <el-button
              title="insert checkbox"
              @click="insertCheckBox"
              type="plain">
              <i class="fa fa-check-square-o" aria-hidden="true"></i>
            </el-button>
          </el-button-group>
        </div>
        <client-only>
          <codemirror
            class="cmEditor"
            ref="cmEditor"
            :options="cmOptions"
            :value="code" />
        </client-only>
      </div>
      <div slot="content">
        <div
          v-if="viewType === 'MD'"
          class="MdView">
          <div
            v-for="(block, blockIndex) in cheatsheets"
            v-if="filter ? block.content.toLowerCase().includes(filter) : true"
            :key="blockIndex"
            :data-mainindex="blockIndex">
            <h1
              @click.right.prevent="editItem(block, null)"
              @click.left.prevent="viewItem(block, null)">
              {{ block.title }}
            </h1>
            <div
              v-for="(element, elementIndex) in block.elements"
              :key="elementIndex"
              >
              <div v-if="filterElement(element, block)">
                <h2
                  @click.right.prevent="editItem(block, element)"
                  @click.left.prevent="viewItem(block, element)">
                  {{ element.title }}
                </h2>
                <div v-html="element.content"></div>
              </div>
              <div
                v-else-if="element.title === 'md' && (filter ? element.content.toLowerCase().includes(filter) : true)"
                v-html="element.content">
              </div>
            </div>
          </div>
        </div>

        <masonry
          class="chsh"
          :cols="massonryCols"
          :gutter="{default: '15px'}"
          v-show="viewType === 'CHSH'">
          <div
            v-for="(block, blockIndex) in cheatsheets"
            v-if="filter ? block.content.toLowerCase().includes(filter) : true"
            class="chsh-block"
            :key="blockIndex"
            :data-mainindex="blockIndex"
            :style="{ backgroundColor: block.color }"
            ref="chshBlocks">
            <input
              type="checkbox"
              class="isNotCollapsed"
              :id="'isNotCollapsed' + blockIndex">
            <label
              class="collapser"
              :for="'isNotCollapsed' + blockIndex">
              <i class="fa fa-chevron-down" aria-hidden="true"/>
            </label>
            <div class="chsh-block-content">
              <div class="chsh-top">
                <h1
                  @click.right.prevent="editItem(block, null)"
                  @click.left.prevent="viewItem(block, null)"
                  class="chsh-title">{{ block.title }}
                </h1>
                <h2 class="chsh-subtitle">
                  <i class="fa fa-trash" aria-hidden="true"></i>
                  <i class="fa fa-plus" aria-hidden="true"></i>
                </h2>
              </div>
              <div class="chsh-links">
                <span
                  v-if="filterElement(element, block)"
                  v-for="(element, elementIndex) in block.elements"
                  @click.right.prevent="editItem(block, element)"
                  @click.left.prevent="viewItem(block, element)"
                  :key="elementIndex" href="#"
                  class="chsh__item--sub chsh-link"
                  :style="{'color': element.content && element.content.trim() ? false : '#ccc'}">
                  <span
                    class="link-inner">
                    {{ element.title }}
                  </span>
                  <i class="fa fa-trash delete-element" aria-hidden="true"></i>
                </span>

                <div
                  @click.right.prevent="editItem(block, element)"
                  v-else-if="element.title === 'md' && (filter ? (block.title.toLowerCase().includes(filter) || element.content.toLowerCase().includes(filter)) : true)"
                  class="chsh__item--sub chsh-md element-md"
                  v-html="element.content"></div>
              </div>
            </div>
          </div>
        </masonry>
      </div>
    </vue-drawer-layout>

    <el-dialog
      width="80%"
      class="ViewItem"
      :visible.sync="viewing.show"
      :title="viewing.title">
      <div
        v-html="viewing.content"></div>
    </el-dialog>
  </div>
</template>

<script>
export default {
  asyncData({ query }) {
    return {
      query
    }
  },
  data() {
    return {
      mdContent: '',
      mdHtml: '',
      filter: '',
      snippetsFilter: '',
      extCheatsheetsFilter: '',
      changedData: false,
      title: 'cheatsheet',
      viewType: 'MD',
      code: '',
      folderExists: false,
      massonryCols: {
        default: 4,
        400: 1,
        700: 2,
        1000: 3,
        1300: 4,
        1600: 5,
        1900: 6,
        2100: 7
      },
      isDrawerEnabled: true,
      isDrawerOpened: false,
      editing: {
        type: 'file',
        title: '',
        blockIndex: false,
        elementIndex: false,
      },
      viewing: {
        show: false,
        type: '',
        title: 'view item',
        content: '',
        blockIndex: false,
        elementIndex: false,
      },
      cmOptions: {},
      watchingFile: true,
      existSnippets: [],
      existExtCheatsheets: [],
      cheatsheets: [],
      colors: ['#F99157', '#5FB3B3', '#C594C5', '#89B784', '#6699CC', '#EC5F67', '#8D89D1', '#EAB853', '#AB7967'],
    }
  },
  beforeMount() {
    if (process.client) {
      this.loadCheatSheet()
      Promise.all([
        this.loadSnippets(),
        this.loadExtCheatsheets()
      ])
    }
  },
  mounted() {
    if (process.client) {
      this.editorSetFileCode()
      $(this.$refs.page).on('click', 'a', (e) => {
        e.preventDefault()
        const href = $(e.currentTarget).attr('href')
        const text = $(e.currentTarget).text()
        if (href === '#copyme') {
          const clipboard = nw.Clipboard.get()
          clipboard.set(text, 'text')
          this.$axios.post('/notify', {
            text,
            title: 'copied to clipboard',
            icon: 'success.png',
          })
       } else if (href === '#opw-note-link') {
          window.location.href = `http://localhost:6767/cheatsheet?path=${path.join(sourcesDir, 'cheatsheets', text)}`
        } else {
          open(href)
        }
        $(e.currentTarget).addClass('visited')
        return false
      })
      try {
        this.$nextTick(() => this.$refs.filterInput.focus())
      } catch (e) {}
      watch(this.query.path, {}, (evt, name) => {
        if (!fs.existsSync(this.query.path)) {
          win.close()
        } else {
          if (this.watchingFile) {
            this.changedData = false
            this.loadCheatSheet()
          }
        }
      })
      this.$refs.filterInput.focus()
      this.cmOptions = {
        tabSize: 2,
        autofocus: true,
        extraKeys: {
          'Shift-Ctrl-D': (cm) => {
            const current_cursor = cm.doc.getCursor()
            const line_content = cm.doc.getLine(current_cursor.line)
            cm.execCommand('goLineEnd')
            cm.execCommand('newlineAndIndent')
            cm.doc.replaceSelection(line_content)
            cm.doc.setCursor(current_cursor.line + 1, current_cursor.ch)
          },
          'Shift-Delete': (cm) => {
            const current_cursor = cm.doc.getCursor()
            const line_content = cm.doc.getLine(current_cursor.line)
            cm.execCommand('deleteLine')
          },
          "Ctrl-D": (cm) => {
            this.$nextTick(() => {
              this.$refs.snippetsFilter.focus()
            })
          },
          'Ctrl-V': (cm) => {
            this.editorPaste(cm)
          },
          'Ctrl-S': (cm) => {
            this.editorSaveContent(cm)
          },
        }
      }
    }
  },
  methods: {
    filterElement(element, block) {
      return element.type === 'element'
        && element.title !== 'md'
        && (
          this.filter
            ? (block.title.toLowerCase().includes(this.filter) || element.title.toLowerCase().includes(this.filter) || element.content.toLowerCase().includes(this.filter))
            : true
        )
    },
    addChshBlock() {

    },
    editorSaveContent(cm) {
      console.log('************* editorSaveContent')
    },
    editorPaste(cm) {
      console.log('************* editorPaste')
    },
    openSublime() {
      const command = os.platform() !== 'win32' 
        ? `/bin/bash -c "cd ~/one-punch-web/sources/cheatsheets && subl -n -a ${this.title}"`
        : `cd /d %USERPROFILE%/one-punch-web/sources/cheatsheets && subl -n -a ${this.title} && exit`
      cmd.run(command)
    },
    openFolder() {
      const cheatsheetsPath = path.join(os.homedir(), 'one-punch-web', 'sources', 'cheatsheets')
      const itemPath = path.join(cheatsheetsPath, 'data', path.parse(this.title).name)
      fs.ensureDirSync(itemPath)
      open(itemPath)
    },
    async pasteSnippet(snippet) {
      this.snippetsFilter = ''
      const { data } = await this.$axios.get(`/snippets/get/${snippet.name}`)
      const editor = this.$refs.cmEditor
      const doc = editor.cminstance.getDoc()
      const cursor = doc.getCursor()
      doc.replaceRange(data, cursor)
      this.$nextTick(() => {
        editor.cminstance.focus()
      })
    },
    async pasteExtCheatsheet(cheatsheet) {
      this.extCheatsheetsFilter = ''
      const editor = this.$refs.cmEditor
      const doc = editor.cminstance.getDoc()
      const cursor = doc.getCursor()
      doc.replaceRange(`{name}(${cheatsheet.name})`, cursor)
      this.$nextTick(() => {
        editor.cminstance.focus()
      })
    },
    wrapByCopy() {
      const editor = this.$refs.cmEditor
      const doc = editor.cminstance.getDoc()
      const cursor = doc.getCursor()
      const text = editor.cminstance.getSelection()
      editor.cminstance.replaceSelection(`[${text}](#copyme)`)
      for (let i = 0; i < 9; i++) {
        editor.codemirror.execCommand('goCharLeft')
      }
      this.$nextTick(() => {
        editor.cminstance.focus()
      })
    },
    wrapByLink() {
      const editor = this.$refs.cmEditor
      const doc = editor.cminstance.getDoc()
      const cursor = doc.getCursor()
      const text = editor.cminstance.getSelection()
      editor.cminstance.replaceSelection(`[${text}]()`)
      editor.codemirror.execCommand('goCharLeft')
      this.$nextTick(() => {
        editor.cminstance.focus()
      })
    },
    wrapByRoundBracket() {
      const editor = this.$refs.cmEditor
      const doc = editor.cminstance.getDoc()
      const cursor = doc.getCursor()
      const text = editor.cminstance.getSelection()
      editor.cminstance.replaceSelection(`(${text})`)
      editor.codemirror.execCommand('goCharLeft')
      this.$nextTick(() => {
        editor.cminstance.focus()
      })
    },
    insertCheckBox() {
      const editor = this.$refs.cmEditor
      const doc = editor.cminstance.getDoc()
      const cursor = doc.getCursor()
      editor.codemirror.execCommand('goLineEnd')
      editor.codemirror.execCommand('newlineAndIndent')
      doc.replaceSelection('- [ ]')
      this.$nextTick(() => {
        editor.cminstance.focus()
      })
    },
    snippetsSearch(queryString, cb) {
      const results = queryString
        ? fuzzysort.go(queryString, this.existSnippets, { keys: ['name'] }).map(item => item.obj)
        : this.existSnippets
      cb(results)
    },
    extCheatsheetsSearch(queryString, cb) {
      const results = queryString
        ? fuzzysort.go(queryString, this.existExtCheatsheets, { keys: ['name'] }).map(item => item.obj)
        : this.existExtCheatsheets
      cb(results)
    },
    async loadSnippets() {
      const { data } = await this.$axios.get('/snippets/get')
      this.existSnippets = data
    },
    async loadExtCheatsheets() {
      const { data } = await this.$axios.get('/cheatsheets/get')
      this.existExtCheatsheets = data
    },
    loadCheatSheet() {
      this.watchingFile = false
      this.mdContent = fs.readFileSync(this.query.path, 'utf8')
      this.cheatsheets = []
      this.mdHtml = this.convertToHtml(this.mdContent)
      this.cheatsheets = this.convertToCheatsheets(this.mdHtml)
      this.title = path.basename(this.query.path)
      if (this.title.endsWith('_CHSH.md')) {
        this.viewType = 'CHSH'
      }
      if (this.editing.type === 'file') {
        this.editorSetFileCode()
      }
      this.changedData = false
      this.watchingFile = true
    },
    editorSetFileCode() {
      this.code = this.convertToMd(this.mdHtml)
      this.editing.type = 'file'
    },
    handleSlideEnd(visible) {
      this.isDrawerOpened = visible
      this.isDrawerEnabled = !visible
    },
    openDrawer() {
      this.$refs.drawer.toggle(true)
      this.isDrawerOpened = true
      this.isDrawerEnabled = false
    },
    closeDrawer() {
      this.$refs.drawer.toggle(false)
      this.isDrawerOpened = false
      this.isDrawerEnabled = true
    },
    saveCheatsheet() {
      const html = this.cheatsheets.map(block => {
        block.content = block.content
          .replace(/<i class="fa fa-check.+?\<\/\i\> /g, `[x] `)
          .replace(/<i class="fa fa-square.+?\<\/\i\> /g, `[ ] `)
        return `<h1>${block.title}</h1>\n${block.content}`
      })
      const md = this.convertToMd(html.join('\n\n')).replace(/-   /g, '- ')
      this.watchingFile = false
      fs.writeFileSync(this.query.path, md, 'utf8')
      this.changedData = false
      this.watchingFile = true
    },
    viewItem(block, element) {
      this.viewing = {
        show: true,
        type: element ? 'element' : 'block',
        title: element ? element.title : block.title,
        content: element ? element.content : block.content,
        blockIndex: block.blockIndex,
        elementIndex: element ? element.elementIndex : false,
      }
    },
    editItem(block, element) {
      this.editing = {
        type: element ? 'element' : 'block',
        title: element ? element.title : block.title,
        blockIndex: block.blockIndex,
        elementIndex: element ? element.elementIndex : false,
      }
      this.code = element
        ? `## ${element.title}\n\n${this.convertToMd(element.content)}`
        : `# ${block.title}\n\n${this.convertToMd(block.content)}`
      this.openDrawer()
    },
    convertToMd(html) {
      TurndownService.prototype.escape = (string) => {
        var escapes = []
        string = string.replace(/_/g, '_')
        string = string.replace(/\[ \]/g, '[ ]')
        string = string.replace(/\[x\]/g, '[x]')
        return escapes.reduce((accumulator, escape) => {
          return accumulator.replace(escape[0], escape[1])
        }, string)
      }
      return turndownService
        .turndown(
          html
            .replace(/<i class="fa fa-check.+?\<\/\i\> /g, `[ ] `)
            .replace(/<i class="fa fa-square.+?\<\/\i\> /g, `[x] `)
        )
        .replace(/-   /g, '- ')
    },
    convertToHtml(md) {
      const renderer = new marked.Renderer()
      let cnt = 0
      try {
        md = md
          .replace(/\{.*\}\(.*[\)]/g, (str) => {
            return str
              .replace(/\(.*[\)]/g, '')
              .replace(/\{|\}/g, '') + ': [' + str
              .replace(/\{.*\}/g, '')
              .replace(/\(|\)/g, '') + '.md](#opw-note-link)'
          })
      } catch (e) {
        console.log(e)
      }
      renderer.listitem = (text) => {
        if (/\[(x|\s)\] /.test(text)) {
          text = text
            .replace(/\[ \] /g, `<i class="fa fa-square-o check" data-num="${cnt}" aria-hidden="true"></i> `)
            .replace(/\[x\] /g, `<i class="fa fa-check-square-o checked" data-num="${cnt}" aria-hidden="true"></i> `)
          cnt++
          return `<li style="list-style: none" data-yes="true">${text}</li>`
        } else {
          return '<li>' + text + '</li>'
        }
      }
      return marked(md, {
        baseUrl: 'http://localhost:6666',
        breaks: false,
        gfm: true,
        headerIds: true,
        headerPrefix: "",
        langPrefix: "language-",
        mangle: true,
        pedantic: false,
        sanitize: false,
        sanitizer: null,
        silent: false,
        smartLists: false,
        smartypants: false,
        xhtml: false,
        renderer,
        highlight: (code) => highlightjs.highlightAuto(code).value
      })
    },
    convertToCheatsheets(html) {
      const $ch = cheerio.load(html, { decodeEntities: false })
      const htmlH1Split = html.split(/\<h1.*\>.*\<\/h1\>/)
      const cheatsheets = []
      let colorIndex = 0
      const getColor = () => {
        let color = this.colors[colorIndex]
        if (!color) {
          colorIndex = 0
          color = this.colors[0]
        } else {
          colorIndex++
        }
        return color
      }
      $ch('h1').each((blockIndex, h1) => {
        const blockContent = htmlH1Split[blockIndex+1]
        const elements = []
        const $chInner = cheerio.load(blockContent, { decodeEntities: false })
        const htmlH2Split = blockContent.split(/\<h2.*\>.*\<\/h2\>/)
        $chInner('h2').each((elementIndex, h2) => {
          const elementContent = htmlH2Split[elementIndex + 1]
          elements.push({
            type: 'element',
            title: $chInner(h2).text(),
            content: elementContent,
            blockIndex,
            elementIndex,
          })
        })
        cheatsheets.push({
          type: 'block',
          title: $ch(h1).text(),
          content: blockContent,
          color: getColor(),
          blockIndex,
          elements,
        })
      })
      return cheatsheets
    }
  }
}
</script>

<style lang="less">
// @import "highlight.js/styles/ocean.css";

.ViewMenu {
  box-sizing: border-box;
  width: 100%;
  height: 40px;
  background-color: #223749;
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  align-items: center;
  padding: 0 10px;
  position: relative;
  ._center {
    position: absolute;
    top: 0;
    height: 100%;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    left: 50%;
    -webkit-transform: translateX(-50%);
    transform: translateX(-50%);
  }
  ._right {
    display: flex;
    flex-direction: row;
    justify-content: center;
    align-items: center;
    .el-button {
      width: 42px;
    }
  }
  ._left {
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    align-items: center;
  }
}

.DrawerContent {
  background-color: #1B2B34;
  height: 100%;
  position: relative;
  ._close {
    position: absolute;
    z-index: 9999;
    top: 0;
    right: 0;
    color: #fff;
    padding: 7px 16px;
    font-size: 20px;
    cursor: pointer;
  }
  ._menu {
    height: 40px;
    background-color: #0F1E28;
    display: flex;
    flex-direction: row;
    justify-content: flex-start;
    align-items: center;
  }
}

.cmEditor {
  height: calc(~"100% - 40px");
  .CodeMirror {
    height: 100%;
  }
}

.MdView {
  height: calc(~"100vh - 80px");
  overflow: auto;
  padding: 0 20px;
  a {
    color: #409EFF !important;
    font-weight: bold;
    text-decoration:  none;
    &:visited {
      color: #409EFF !important;
    }
    &.visited {
      color: #E6A23C !important;
    }
  }
  a[href="#copyme"] {
    color: #459041 !important;
    &.visited {
      color: #F56C6C !important;
    }
  }
  img {
    max-width: 100%;
  }
}

.ViewItem {
  a {
    color: #409EFF !important;
    font-weight: bold;
    text-decoration:  none;
    &:visited {
      color: #409EFF !important;
    }
    &.visited {
      color: #E6A23C !important;
    }
  }
  a[href="#copyme"] {
    color: #459041 !important;
    &.visited {
      color: #F56C6C !important;
    }
  }
  img {
    max-width: 100%;
  }
  .el-dialog__body {
    padding: 0 20px 30px 20px;
  }
}

.chsh {
  box-sizing: border-box;
  height: calc(~"100vh - 80px");
  padding: 10px;
  position: relative;
  overflow-y: auto;
  a {
    text-decoration: none;
  }
  a {
    color: #409EFF !important;
    font-weight: bold;
    text-decoration:  none;
    &:visited {
      color: #409EFF !important;
    }
    &.visited {
      color: #E6A23C !important;
    }
  }
  a[href="#copyme"] {
    color: #459041 !important;
    &.visited {
      color: #F56C6C !important;
    }
  }
  img {
    max-width: 100%;
  }
  ul {
    padding-left: 20px;
    li {
      word-break: break-word;
    }
  }
  .chsh-md {
    background-color: #FFF;
    border-radius: 5px;
    color: rgb(62, 63, 58);
    font-size: 14px;
    word-break: break-word;
  }
  .chsh-block {
    border-radius: 10px;
    padding: 10px;
    padding-bottom: 20px;
    margin-bottom: 15px;
    overflow: hidden;
    position: relative;
    .chsh-block-content {
      max-height: 322px;
      overflow: hidden;
    }
    .collapser {
      position: absolute;
      top: 332px;
      width: 100%;
      text-align: center;
      left: 0;
      background-color: rgba(255, 255, 255, 0.5);
      cursor: pointer;
      transition: all 0.3s;
      i {
        transition: all 0.3s;
      }
      &:hover {
        background-color: rgba(255, 255, 255, 0.9);
      }
    }
    .isNotCollapsed {
      visibility: hidden;
      position: absolute;
      top: -9999px;
      left: -9999px;
      &:checked ~ .chsh-block-content {
        max-height: none;
      }
      &:checked ~ .collapser {
        bottom: 0;
        top: auto;
        i {
          transform: rotateZ(-180deg);
        }
      }
    }
  }
  .add-block {
    border-radius: 10px;
    padding: 10px;
    margin-bottom: 30px;
    overflow: hidden;
    color: #FFF;
    font-size: 40px;
    border: 3px dashed #FFF;
    text-align: center;
    cursor: pointer;
    &:hover {
      background-color: #FFF;
      color: #343D46;
      transition: all 0.3s;
    }
  }

  .chsh-top {
    padding: 5px;
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    align-items: stretch;
    margin-bottom: 10px;
    h1 {
      font-size: 16px;
      font-weight: bold;
      color: #343D46;
      margin: 0;
      cursor: pointer;
      width: 100%;
      transition: all 0.3s;
    }

    h1:hover {
      color: #FFF;
    }

    h2 {
      font-size: 14px;
      margin: 0;
      color: #343D46;
      cursor: pointer;
    }
  }

  .chsh-link {
    display: block;
    padding: 2px 5px;
    color: #FFF;
    font-size: 16px;
    border-radius: 10px;
    position: relative;
    padding-right: 25px;
    cursor: pointer;
    .link-inner {
      display: block;
      width: 100%;
    }
    .delete-element {
      position: absolute;
      top: 5px;
      right: 7px;
      z-index: 88;
      transition: all 0.3s;
      opacity: 0;
      cursor: pointer;
      &:hover {
        color: #fff;
      }
    }
    .move-element {
      position: absolute;
      top: 5px;
      right: 30px;
      z-index: 88;
      transition: all 0.3s;
      opacity: 0;
      cursor: pointer;
    }

    &:hover {
      color: #343D46;
      background-color: rgba(255, 255, 255, 0.2);

      .delete-element {
        opacity: 1;
      }

      .move-element {
        opacity: 1;
      }
    }
  }
  .chsh-links {
    min-height: 10px;
    .chsh-link:nth-child(odd) {
      background-color: rgba(0, 0, 0, 0.1);
    }
  }

  .chsh-block.selected {
    -webkit-box-shadow: inset 0 0 0 1px #FFF;
    -moz-box-shadow: inset 0 0 0 1px #FFF;
    box-shadow: inset 0 0 0 1px #FFF;
  }

  .chsh-subtitle {
    display: flex;
    flex-direction: row;
    justify-content: flex-end;
    align-items: flex-start;
    padding-left: 5px;

    i {
      padding: 5px;
      padding-right: 0;
      padding-top: 2px;
      transition: all 0.3s;
      &.fa-trash {
        position: relative;
        top: -1px;
        right: 3px;
      }
    }
    i:hover {
      color: #FFF;
    }
  }
  .chsh-md img, .chsh_link_content img, .sort_content img, p img {
    max-width: 100%;
    position: relative;
    left: 50%;
    -webkit-transform: translateX(-50%);
    transform: translateX(-50%);
  }

  .chsh-md p {
    padding: 5px 10px;
  }

  .chsh-md h3 {
    padding: 0 8px;
  }
}


</style>